﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports System.Windows.Forms
Imports Syncfusion.Windows.Forms.Chart

Namespace WindowsFormsApplication1
	Partial Public Class Form1
		Inherits Form

		Private chart As New ChartControl()

		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
			Dim data As New List(Of chartData)()
			Dim filteredData As New List(Of XY)()
			Dim date1 As New Date(2017, 1, 8, 1, 1,1)
			Dim date2 As New Date(2017, 1, 9, 2, 2,2)
			For i As Integer = 1 To 24
				If i<13 Then
				   data.Add(New chartData(i, i+1, New Date(2017, 1, 1, 1, i + 1, 1), New Date(2017, 1, 1, 1, i+ 3, 1), date1, New Date(2017, 1, i + 2, 1, 1, 1)))
				Else
				   data.Add(New chartData(i-12, i + 1, New Date(2017, 1, 1, 1, i + 1, 1), New Date(2017, 1, 1, 1, i + 3, 1), date2, New Date(2017, 1, i + 2, 1, 1, 1)))
				End If
			Next i

			Dim filter = data.Select(Function(x) x.employee_Id).Distinct().ToList()
			Me.chart.PrimaryXAxis.ValueType = ChartValueType.DateTime
			Me.chart.PrimaryYAxis.ValueType = ChartValueType.DateTime
			Me.chart.PrimaryXAxis.DateTimeFormat = "HH:mm"
			Me.chart.PrimaryYAxis.IntervalType = ChartDateTimeIntervalType.Days
			Me.chart.PrimaryXAxis.IntervalType = ChartDateTimeIntervalType.Minutes
			Me.chart.PrimaryYAxis.DateTimeFormat = "dd"
			 Me.chart.Title.Text = "Working Time"
			Me.chart.PrimaryYAxis.Title = "Date"
			Me.chart.PrimaryXAxis.Title = "Time"
			Me.chart.LegendPosition = ChartDock.Top
			Dim sereisColor() As Color = { Color.Orange, Color.Blue, Color.Red, Color.Red, Color.White, Color.BlueViolet, Color.White, Color.Green, Color.Red, Color.White, Color.Red, Color.Gray }
			Dim seriesName() As String = { "WAS TED","HTC 7020","WAS TED","HTC 7061","BREAK","HTC 7061","LUNCH BREAK", "HTC 7061","NO INPU","Evening Br","Wasted","HTC 7128"}
			For j As Integer = 0 To filter.Count - 1

				Dim series As New ChartSeries(seriesName(j))
				series.Type = ChartSeriesType.StackingBar
                Dim xData2 As DateTime() = data.Where(Function(x) x.employee_Id = filter(j)).[Select](Function(x) x.date_Start).ToArray()
                Dim yData2 As DateTime() = data.Where(Function(x) x.employee_Id = filter(j)).[Select](Function(x) x.time_Start).ToArray()

				For k As Integer = 0 To xData2.Length - 1
					series.Points.Add(xData2(k), yData2(k).ToOADate())
				Next k
				series.Style.Interior = New Syncfusion.Drawing.BrushInfo(sereisColor(j))
				Me.chart.Series.Add(series)
			Next j
			Me.chart.ShowToolbar = True
			Me.chart.Size = New Size(800, 450)
			Me.Controls.Add(chart)
		End Sub

	End Class
	Public Class XY
		Public Property X() As Date
		Public Property Y() As Date
	End Class
	Public Class chartData
		Public Sub New(ByVal employee_id As Double, ByVal Product_id As Double, ByVal time_start As Date, ByVal time_finish As Date, ByVal date_start As Date, ByVal date_finish As Date)
			Me.employee_Id = employee_id
			Me.Product_Id = Product_id
			Me.time_Start = time_start
			Me.time_Finish = time_finish
			Me.date_Start = date_start
			Me.date_Finish = date_finish
		End Sub
		Public Property employee_Id() As Double
		Public Property Product_Id() As Double
		Public Property time_Start() As Date
		Public Property time_Finish() As Date
		Public Property date_Start() As Date
		Public Property date_Finish() As Date

	End Class
End Namespace
